
var helper = ''; // Pro meziuložení instance třídy

//////////// Constructors

// Třída tabulky
function Table()
{}

//////////// Attributes
Table.prototype.rows = 1;
Table.prototype.columns = 1;
Table.prototype.title = 'Table';
Table.prototype.header = new Array();
Table.prototype.data = new Array();
Table.prototype.sorted = '';
Table.prototype.renderedObject = '';
Table.prototype.legend = '';

//////////// Methods

// Attrs
Table.prototype.setTitle = function(title)
{
	this.title = title;
};

Table.prototype.setColumnCount = function(n)
{
	this.columns = n;
};

Table.prototype.setHeaderTitles = function(headerNames)
{
	this.header = headerNames;
};

Table.prototype.setRowCount = function(n)
{
	this.rows = n;
};

// Data

Table.prototype.addRow = function()
{
	if(arguments.length != this.columns)
	{
		alert('Chybný vstup pro radek');
		return;
	}
	
	var arr = new Array();
	
	for(var i = 0;i < arguments.length;i++)
	{
		arr.push(arguments[i]);
	}
	
	this.data.push(arr);
};

Table.prototype.addRowFromString = function(rowString)
{
	str = rowString.trim();
	if(typeof(str) !== 'string' || str.indexOf(';') == 0 || str.indexOf(';') === str.length - 1)
	{
		alert('Chybný vstup pro radek zadany retezcem');
		return;
	}	
	
	var strs = str.split(';');
	
	this.data.push(strs);	
};

Table.prototype.addRowsJson = function(json)
{
	var error = false;
	if(!Array.isArray(json))
	{
		error = true;
	}
	else
	{
		json.forEach(function(row)
		{
			if(!Array.isArray(row) || row.count != this.columns)
			{
				error = true;
			}
		});
	}
	
	if(error)
	{
		alert('Chybný vstup');
		return;
	}
	
	this.data = this.data.concat(json);
};

// Render

Table.prototype.createTable = function(id)
{
	var str = '<table class="tablejs-table"><legend class="tablejs-legend">' + this.title + '</legend>';
	
	if(this.header.length !== 0)
	{
		str += '<thead><tr>';
		
		this.header.forEach(function(item)
		{
			str += '<th class="tablejs-header">' + item + '</th>';
		});
		
		str += '</tr></thead>'
	}
	
	
	if(this.data.length !== 0)
	{
		str += '<tbody>';
		
		var its = 0;
		var helper = this;
		this.data.forEach(function(row)
		{
			if(its < helper.rows)
			{
				str += '<tr class="tablejs-body-row">';
				
				row.forEach(function(item)
				{
					str += '<td>' + item + '</td>';
				});
				
				str += '</tr>';
				its++;
			}
		});
		str += '</tbody>';
	}
	
	str += '</table>';
	var $div = $('#' + id);
	$div.append(str);
	this.renderedObject = $('table.tablejs-table').last();
	this.legend = $('legend.tablejs-legend');
	this.finish();
};




// Nastaví odpovídající jQuery handlery
Table.prototype.finish = function()
{
	helper = this;
	
	$('tr.tablejs-body-row').hover(
			function()
			{
				$(this).css('backgroundColor','skyblue');
			},
			function()
			{
				$(this).css('backgroundColor','initial');
			}
	);
			
	$('th.tablejs-header').hover(
			function()
			{
				$('tr.tablejs-body-row td:nth-child(' + parseInt($(this).index() + 1) + ')').css('backgroundColor','yellow');
				$(this).css('backgroundColor','yellow');
			},
			function()
			{
				$(this).css('backgroundColor','initial');
				$('tr.tablejs-body-row td:nth-child(' + parseInt($(this).index() + 1) + ')').css('backgroundColor','initial');
			}
	);	
	
	$('th.tablejs-header').click(function()
		{
			
			if(helper.sorted == '' || helper.sorted == 'down')
			{
				helper.sorted = 'up';
			}
			else
			{
				helper.sorted = 'down';
			}
			
			var index = $(this).index();
			
			for(var j = 0;j < helper.data.length;j++)
			{
				for(var i = 0;i < helper.data.length - 1;i++)
				{
					var condition;
					
					if(helper.sorted == 'up')
					{
						condition = helper.data[i][index] > helper.data[i + 1][index];
					}
					else
					{
						condition = helper.data[i][index] < helper.data[i + 1][index];
					}
					
					if(condition)
					{
						var first = helper.data[i];
						helper.data[i] = helper.data[i + 1];
						helper.data[i + 1] = first;
					}
				}
			}
			
			var parent = helper.renderedObject.parent();
			helper.renderedObject.remove();
			helper.legend.remove();
			helper.createTable(parent.attr('id'));
		}
	);
	
	$('.tablejs-body-row td').dblclick(function()
	{
		var val = $(this).html();
		
		$(this).empty();
		$(this).append('<input class="tablejs-input" type="text" data-row="' + $(this).parent().index() + '" data-column="' + $(this).index() + '" value="' + val + '">');
		
		$('.tablejs-input').keydown(function(e)
		{
			var code = e.keyCode || e.which;
			if(code == 13)
			{
				var row = $(this).data('row');
				var column = $(this).data('column');
				helper.data[row][column] = $(this).val();
				
				var parent = helper.renderedObject.parent();
				helper.renderedObject.remove();
				helper.legend.remove();
				helper.createTable(parent.attr('id'));
			}
		});
	});
}
